Subject: Re: [PATCH] CMAC support for CryptoAPI, fixed patch issues, indent, and testmgr build issues

From: Tom St Denis <[email-masked]>
Date: Wed, 23 Jan 2013 09:46:23 -0500 (EST)

----- Original Message -----
> From: "Jussi Kivilinna" <[email-masked]>
> To: "Tom St Denis" <[email-masked]>
> Cc: [email-masked], "Herbert Xu" <[email-masked]>, "David Miller" <[email-masked]>,
> [email-masked], "Steffen Klassert" <[email-masked]>, [email-masked]
> Sent: Wednesday, 23 January, 2013 9:36:44 AM
> Subject: Re: [PATCH] CMAC support for CryptoAPI, fixed patch issues, indent, and testmgr build issues
> 
> Quoting Tom St Denis <[email-masked]>:
> 
> > Hey all,
> >
> > Here's an updated patch which addresses a couple of build issues
> > and
> > coding style complaints.
> >
> > I still can't get it to run via testmgr I get
> >
> > [  162.407807] alg: No test for cmac(aes) (cmac(aes-generic))
> >
> > Despite the fact I have an entry for cmac(aes) (much like
> > xcbc(aes)...).
> >
> > Here's the patch to bring 3.8-rc4 up with CMAC ...
> >
> > Signed-off-by: Tom St Denis <[email-masked]>
> >
> <snip>
> > diff --git a/include/uapi/linux/pfkeyv2.h
> > b/include/uapi/linux/pfkeyv2.h
> > index 0b80c80..d61898e 100644
> > --- a/include/uapi/linux/pfkeyv2.h
> > +++ b/include/uapi/linux/pfkeyv2.h
> > @@ -296,6 +296,7 @@ struct sadb_x_kmaddress {
> >  #define SADB_X_AALG_SHA2_512HMAC	7
> >  #define SADB_X_AALG_RIPEMD160HMAC	8
> >  #define SADB_X_AALG_AES_XCBC_MAC	9
> > +#define SADB_X_AALG_AES_CMAC_MAC	10
> >  #define SADB_X_AALG_NULL		251	/* kame */
> >  #define SADB_AALG_MAX			251
> 
> Should these values be based on IANA assigned IPSEC AH transform
> identifiers?
> 
> https://www.iana.org/assignments/isakmp-registry/isakmp-registry.xml#isakmp-registry-6

There is no CMAC entry apparently ... despite the fact that CMAC is a proposed RFC standard for IPsec.

It might be safer to move that to 14 since it's currently unassigned and then go through whatever channels are required to allocate it.  Mostly this affects key setting.  So this means my patch would break AH_RSA setkey calls (which the kernel doesn't support anyways).

Tom